class Stack:
    def __init__(self):
        self.stack_vals = []
        self.len = 0

    def push(self, val):
        self.stack_vals.append(val)
        self.len += 1

    def pop(self):
        if self.is_empty():
            return None
        res = self.stack_vals[-1]
        self.stack_vals = self.stack_vals[0:-1]
        self.len -= 1
        return res

    def __repr__(self):
        out = '|'
        for i in range(self.len):
            out += str(self.stack_vals[i]) + ' '
        out += '<-top'
        return out

    def peek(self):
        if self.is_empty():
            return None
        return self.stack_vals[-1]

    def __len__(self):
        return self.len

    def is_empty(self):
        return self.len == 0


class LinkedListUsingStack:
    def __init__(self):
        self.stack = Stack()
        self.len = 0

    def __len__(self):
        return self.len

    def __repr__(self):
        help_stack = Stack()
        out = ''
        while self.stack.is_empty() != True:
            tmp = self.stack.pop()
            help_stack.push(tmp)
            out += '[' + str(tmp) + ']' + '->'
        while help_stack.is_empty() != True:
            self.stack.push(help_stack.pop())
        return out

    def add_at_start(self, val):
        self.stack.push(val)
        self.len += 1

    def insert(self, val, loc):
        if not (0 <= loc <= len(self)):
            print("Invalid location")
            return
        help_stack = Stack()
        while loc > 0:
            help_stack.push(self.stack.pop())
            loc -= 1
        self.stack.push(val)
        while help_stack.is_empty() != True:
            self.stack.push(help_stack.pop())
        self.len += 1

    def delete(self, loc):
        if not (0 <= loc < len(self)):
            print("Invalid location")
            return
        help_stack = Stack()
        while loc > 0:
            help_stack.push(self.stack.pop())
            loc -= 1
        self.stack.pop()
        while help_stack.is_empty() != True:
            self.stack.push(help_stack.pop())
        self.len -= 1

    def __getitem__(self, loc):
        if not (0 <= loc < len(self)):
            print("Invalid location")
            return
        help_stack = Stack()
        while loc > 0:
            help_stack.push(self.stack.pop())
            loc -= 1
        res = self.stack.pop()
        self.stack.push(res)
        while help_stack.is_empty() != True:
            self.stack.push(help_stack.pop())
        return res


if __name__ == '__main__':
    lst_use_stack = LinkedListUsingStack()
    lst_use_stack.add_at_start(5)
    lst_use_stack.add_at_start(6)
    lst_use_stack.add_at_start(7)
    lst_use_stack.add_at_start(8)
    print(lst_use_stack)
    lst_use_stack.insert(15, 2)
    print(lst_use_stack)
    lst_use_stack.delete(4)
    print(lst_use_stack)
